#ifndef __DllToLib_inc__
#define __DllToLib_inc__


#include "objbase.inc"
#include "shellapi.inc"
#include "commctrl.inc"
#include "shlobj.inc"
#include "psapi.inc"
#include "tools\\gui.inc"
#include "stdio.inc"
#include "resource.inc"
#include "shlwapi.inc"
#include "zlib.inc"

#define OFNSAVEFLAGS  OFN_ENABLESIZING|OFN_EXPLORER|OFN_OVERWRITEPROMPT
#define OFNOPENFLAGS  OFN_ENABLESIZING|OFN_EXPLORER|OFN_FILEMUSTEXIST
declare extern __s2w alias s2w(wstring *wsz),wstring *;
extern _printbuf as string;

struct COMPILERDATA
{
	// work path
	dstring szWorkDir[MAX_PATH];        // c:\program files\dll2lib\
	// dll
	dstring szDllPath[MAX_PATH];        // c:\windows\system32\scilexer.dll
	dstring szCompressedPath[MAX_PATH]; // c:\program files\dll2lib\something.dl_ (or szDllPath if not compressed)
	dstring szDllDataLabel[64];         // SciLexer_dll
	dstring szZlibPath[MAX_PATH];       // c:\program files\dll2lib\zlib1.tmp - if 'embed zlib' checked
	dstring szZlibDataLabel[64];        // zlib1_dll
	// asm
	dstring szPrefix[32];               // __imp_
	dstring szAsmPath[MAX_PATH];        // <path>dllexports.asm
	dstring szObjPath[MAX_PATH];        // <path>dllexports.obj
	dstring szLoaderFunction[128];      // __LoadSci
	dstring szUnloaderFunction[128];    // __UnloadSci
	dstring szCommandline[MAX_PATH*2];  // need more ?

	dstring szLibPath[MAX_PATH];        // where to create library

	// createprocess
	SECURITY_ATTRIBUTES security;
	PROCESS_INFORMATION process;
	STARTUPINFO         info;
	// booleans
	BOOL bIsCompressed;
	BOOL bExportStd;
	BOOL bExportDec;
	BOOL bIncludeZlib;      // embed zlib for decompressing // todo!
	BOOL bUseExternC;
	DWORD dwCompressedSize;
	DWORD dwOriginalSize;
	// todo: strings for api names
}

class CDlg
{
	// window messages
	declare OnCreate();
	declare OnClose();
	declare OnTimer(HWND hwnd);
	declare OnControl(int code,int id);
	declare OnMessagebox(HWND hwnd);
	declare OnNotify(NMHDR *pnmhdr);
	declare OnDrop(HDROP hDrop);
	declare OnMenuSelect(int id);
	// settings
	declare LoadSettings();
	declare SaveSettings();
	declare LoadSettingsString(int ctlID,string szValueName),BOOL;
	declare LoadSettingsBool(int ctlID, string szValueName);
	// listview
	declare lvGetItemText(int item,int subitem,string *text,int cch),string *;
	declare lvSetItemText(int item,int subitem,string *text);
	declare lvUndecorate();
	declare lvResetNames();
	declare lvRenameSelected();
	declare lvCopyItemText(int item,int subitem);
	declare lvSaveNames();
	declare lvSelectAllItems();
	declare lvContextMenu(NMITEMACTIVATE *pnmhdr);
	declare lvCanUnecorate(int item),BOOL;
	declare lvDecorateUsingImplib();
	// general
	declare SendControlMessage(int id,UINT uMsg,WPARAM wParam,LPARAM lParam),LRESULT;
	declare ToggleAdvancedView();
	declare BrowseOpenFile(int editID,string DefaultName,string szFlter,opt BOOL save=FALSE);
	declare BrowseDirectory(int editID,string *title);
	declare UpdateLibraryPath(string *dllpath);
	declare AttachButtonToEdit(int idEdit,int idButton);
	declare InitHyperlinkControl(HWND hwndUrl,string *pUrl,opt int ctlId=0);
	// clipboard
	declare SetClipboardString(string *str,opt int _len=-1);
	// loading dll
	declare LoadFile(string *path);
	declare LoadDll(string *path,opt BOOL warnings=TRUE),BOOL;
	declare PostDropFiles(string *path);
	declare FreeDll();
	declare Cleanup();
	// server
	declare DumpMethods();
	// unzip RCDATA resource to heap (use FreeHeap to free memory)
	declare DecompressRcdata(string *id,string *ppszAsmTxt,DWORD *ppLength),BOOL;
	// clipboard
	declare CopySubMain();

	declare OnCreateLib(); // manages temporary files
	declare CreateLib();   // use OnCreateLib instead!
	declare FindLinkerPath(string *szBinPath),BOOL;
	// compressing
	declare CompressDll(COMPILERDATA data),BOOL; // data.dwOriginalSize is set
	declare CreateAsmFile(COMPILERDATA data),BOOL;
	declare CompileAsmFile(COMPILERDATA data),BOOL;

	declare UpdateLoadLibraryFlags();

	// experimental
	declare ResolveStdcall();
	declare ResolveCdecl();
	declare ResolveStdcallThread();

	HWND    m_hwnd;
	HICON   m_hIcon;
	HKEY    m_hkMain;          // valid inside load/save settings
	DWORD   m_UndecorateFlags; // todo: allow modification
	int     m_bannerId;        // last control id for statusbar help string
	BOOL    m_MenuActivated;
	BOOL    m_bLoadLibraryFlags;

	// current dll data
	IMAGE_DOS_HEADER *m_pDosHdr;
	IMAGE_NT_HEADERS *m_pNtHdr;
	HMODULE           m_hDll;
	IMAGE_EXPORT_DIRECTORY *m_exports;

	string *m_lpszCompressed; // temporary file, valid only inside OnCreateLib()
	string *m_lpszAsmFile;    // temporary file, valid only inside OnCreateLib()
	string *m_lpszObjFile;    // temporary file, valid only inside OnCreateLib()
	string *m_lpszZlibFile;   // temporary file, valid only inside OnCreateLib()
	string *m_lpszLibFile;    // temporary file, valid only inside OnCreateLib()

	dstring szImplibPath[MAX_PATH]; // the last iport library to decorate names
}

// private data for hyperlink control
struct LINKPROP
{
	WNDPROC  wndproc;      // original WindowProc
	HCURSOR  hCursorHand;  // hand cursor (active)
	HFONT    hFont;        // normal font
	HFONT    hFontHot;     // underlined font, DeleteObject()
	HFONT    hFontCurrent;
	COLORREF link;         // The color of shortcuts that have not yet been visited
	COLORREF alink;        // The color for the active link. Changed to vlink if clicked
	COLORREF vlink;        // The color of shortcuts that have already been visited
	COLORREF color;        // current link color
	BOOL     bMouseMoved;  // if mouse down/up without moving: click
	int      ctlId;        // send WM_COMMAND if link was clicked
	dstring  url[1];
}

/*

** used externals **

__imp_ExitProcess
__imp_GetProcAddress
__imp_VirtualAlloc
__imp_VirtualFree
__imp_VirtualProtect
__imp_IsBadReadPtr
__imp_MessageBoxA
__imp_FreeLibrary
__imp_LoadLibraryA
__imp_malloc
__imp_realloc
__imp_free
__imp_memcpy
__imp_sprintf
__imp_memset
__imp__stricmp

** optional **

__imp_uncompress
__imp_zError

*/



#endif
